#include "FS.h"
ESP8266HTTPUpdateServer httpUpdater;
String Mitteilung = "";
String AltePasswort;


unsigned int hexToDec(String hexString) {

  unsigned int decValue = 0;
  int nextInt;

  for (int i = 0; i < hexString.length(); i++) {

    nextInt = int(hexString.charAt(i));
    if (nextInt >= 48 && nextInt <= 57) nextInt = map(nextInt, 48, 57, 0, 9);
    if (nextInt >= 65 && nextInt <= 70) nextInt = map(nextInt, 65, 70, 10, 15);
    if (nextInt >= 97 && nextInt <= 102) nextInt = map(nextInt, 97, 102, 10, 15);
    nextInt = constrain(nextInt, 0, 15);

    decValue = (decValue * 16) + nextInt;
  }

  return decValue;
}

void LeseEeprom(char *daten, int lenge)
{
  char a;
  do {
    a = EEPROM.read(z);
    *daten = a;
    daten++;
    z++;
    lenge--;
    if (!lenge)break;
  }
  while (a);
}

void LeseEepromStr(String *daten, int lenge)
{
  char a;
  *daten = "";
  do {
    a = EEPROM.read(z);
    *daten += String(a);
    z++;
    lenge--;
    if (!lenge)break;
  } while (a);
}

void SchreibeEeprom (String k)
{
  int i = 0, blja = 64;
  int  pos, wert;
  char Buchstabe;
  String HexZahl, ersatz = "f";
  k.replace("+", " ");

  while (blja--)
  {
    pos = k.indexOf('%');   // Kodierte zeichen enthalten
    if (pos < 0)break;
    HexZahl = k.substring(pos + 1, pos + 3); // Position finden
    wert = hexToDec(HexZahl);
    ersatz[0] = wert;               //Int to Chahr im String
    HexZahl = "%" + HexZahl;        //Suchmuster finden
    k.replace(HexZahl, ersatz);
  }

  while (k[i])
  {
    EEPROM.write(z, k[i]);
    z++;
    i++;
  }
  EEPROM.write(z, '\0');
  z++;
}

void Ereignis_Setup()			// Wird ausgeuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  Mitteilung = "";
  if (!SPIFFS.begin()) Serial.println("Failed to mount file system");
  File DataFile = SPIFFS.open("/WEBsetMQTT.html", "r");
  if (!DataFile)Serial.println("Failed to open log.txt");
  server.sendHeader("Cache-Control", "no-cache");
  size_t sent = server.streamFile(DataFile, "text/html");
  DataFile.close();
}

void Ereignis_daten()			// Wird ausgeuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  int i;
  String temp = "var daten = [";              // Sternhen einfпїЅgen beim Passwortanzeige
  String TempDaten;
  z = 0;                        // EEPROM Star den Datensatzes
  LeseEepromStr(&TempDaten, 50);
  temp += "\"" + TempDaten + "\", ";
  LeseEepromStr(&TempDaten, 50);
  AltePasswort = TempDaten;
  if (TempDaten.length() > 2) for (i = 1; i < (TempDaten.length() - 1); i++) TempDaten[i] = '*';
  temp += "\"" + TempDaten + "\"";
  for (i = 2; i < 9; i++)
  {
    LeseEepromStr(&TempDaten, 60);
    temp += ", \"" + TempDaten + "\"";
  }
  temp += " ]\r\n";
  temp+="var Mitteilung=\""+Mitteilung+"\"\r\n";
  temp += "var Firmware=\"1.0\"\r\n";
  temp += "var ChipID1=\"" + String(esp.getChipId()) + "\"\r\n";
  server.sendHeader("Cache-Control", "no-cache");
  server.send(200, "text/plain", temp);
}

void formular()			// Wird ausgeuehrt wenn "http://<ip address>/setup.php"
{
  z = 0;
  SchreibeEeprom (server.arg(0));
  String temp1 = server.arg(1);
  if (temp1[2] != '*') SchreibeEeprom (temp1); // wenn mit *
  else SchreibeEeprom (AltePasswort);                   // dann geladene pass abspeichern
  for (int i = 2; i < 9; i++)
  {
    SchreibeEeprom (server.arg(i));
  }
  EEPROM.commit();
  z = 0;                        // EEPROM Star den Datensatzes
  Mitteilung = "Gespeichert!";
  if (!SPIFFS.begin()) Serial.println("Failed to mount file system");
  File DataFile = SPIFFS.open("/WEBsetMQTT.html", "r");
  if (!DataFile)Serial.println("Failed to open log.txt");
  server.sendHeader("Cache-Control", "no-cache");
  size_t sent = server.streamFile(DataFile, "text/html");
  DataFile.close();
}

void handleNotFound()
{
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += ( server.method() == HTTP_GET ) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for ( uint8_t i = 0; i < server.args(); i++ ) {
    message += " " + server.argName ( i ) + ": " + server.arg ( i ) + "\n";
  }
  server.send ( 404, "text/plain", message );
}


void Einstellen()
{
  EEPROM.begin(512);                                 // EEPROM initialisieren mit 200 Byts
  z = 0;                        // EEPROM Star den Datensatzes
  boolean endlos = 1;
  WiFi.mode(WIFI_AP);			// access point modus
  WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
  WiFi.softAP("MQTT Sonoff Setup", "tiramisu");	// Name des Wi-Fi netzes
#if defined DNS
  dnsServer.start(DNS_PORT, "*", apIP);
#endif
  delay(500);					// Abwarten 0,5s
  server.onNotFound ( handleNotFound );
  server.on("/", Ereignis_Setup);

  server.on("/daten.js", Ereignis_daten);
  server.on("/setup.php", formular);
  httpUpdater.setup(&server);
  server.begin();				// Starte den Server

  while (endlos)
  {
#if defined DNS
    dnsServer.processNextRequest();
#endif
    server.handleClient();

  }
}


